<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>

    <script>
        /* 
                                                                                                                                            Faça um algoritmo que retorne a letra mais repetida de uma string
                                                                                                                                        */
        const LetraMaisRepetida = (word) => {
            const palavraSeparada = word.split('');
            let Resultado = {};

            for (let i = 0; i < palavraSeparada.length; i++) {
                if (Resultado[palavraSeparada[i]]) {
                    Resultado[palavraSeparada[i]]++;
                } else {
                    Resultado = {
                        ...Resultado,
                        [palavraSeparada[i]]: 1
                    };
                }
            }

            console.log(Object.keys(Resultado).reduce((a, b) => Resultado[a] > Resultado[b] ? a : b));
        };

        LetraMaisRepetida('fdgdfgff');
        LetraMaisRepetida('Lorem ipsum');
        LetraMaisRepetida('adsassdasd');
        LetraMaisRepetida('testeeeee');

        // Resultados esperados
        //console.log(mostUsedChar("fdgdfgff"), 'f') // f
        //console.log(mostUsedChar("Lorem ipsum"), 'm') // m
        //console.log(mostUsedChar("adsassdasd"), 's') // s
        //console.log(mostUsedChar("testeeeee"), 'e') // e
    </script>
</body>

</html>